Subject: Re: [VLAN]: translate IF_OPER_DORMANT to netif_dormant_on()

From: Ben Greear <[email-masked]>
Date: Wed, 05 Jul 2006 14:17:00 -0700

Patrick McHardy wrote:
> Stefan Rompf wrote:
> 
>>Am Dienstag 04 Juli 2006 12:07 schrieb Patrick McHardy:
>>
>>
>>
>>>>-	new_dev->state = real_dev->state & VLAN_LINK_STATE_MASK;
>>>>+	new_dev->state = real_dev->state & ~(1<<__LINK_STATE_START);

This change looks funky because it ignores the link state mask.

>>Anyway, is it good to propagate __LINK_STATE_PRESENT then? The same situation 
>>here, add a VLAN while the main interface is "not present", and you are out. 
>>Can you try to revert the quoted part of my patch, I'll rethink which flags 
>>should be copied on device creation.
> 
> 
> I tried both adding LINK_STATE_XOFF to the negated flags and using
> VLAN_LINK_STATE_MASK, both as expected solve the problem for me.
> I have to admit I was wondering about LINK_STATE_PRESENT as well
> (was going to complain about that too until I noticed it is also
> set in VLAN_LINK_STATE_MASK). Maybe Ben can tell us the idea behind
> this?

I believe this link-state logic was added by someone else.  I'm not
sure exactly what these flags are supposed to do, so I am not sure if they
should be propagated to the VLAN or not.

Ben

-- 
Ben Greear <[email-masked]>
Candela Technologies Inc  http://www.candelatech.com